import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DebugArithmetic {


    /**arithmetic of the QI class*/

    public static void test0() {
	System.out.println("QI arithmetic");
	QI A=Debugger.randomQI();
	QI B=Debugger.randomQI();
	QI C1=QI.plus(A,B);
	QI C2=QI.minus(A,B);
	QI C3=QI.times(A,B);

	double a=A.toDouble();
	double b=B.toDouble();
	double c1=C1.toDouble();
	double c2=C2.toDouble();
	double c3=C3.toDouble();
	double d1=a+b;
	double d2=a-b;
	double d3=a*b;
	System.out.println("compare");
	System.out.println(c1+" "+d1);
	System.out.println(c2+" "+d2);
	System.out.println(c3+" "+d3);
    }


    /**arithmetic of the QI2 class*/

    public static void test1() {
	System.out.println("QI2 arithmetic");
	QI2 A=Debugger.randomQI2();
	QI2 B=Debugger.randomQI2();
	QI2 C1=QI2.plus(A,B);
	QI2 C3=QI2.times(A,B);
	QI2 C4=QI2.pow(A,3);
	double a=A.toDouble();
	double b=B.toDouble();
	double c1=C1.toDouble();
	double c3=C3.toDouble();
	double c4=C4.toDouble();
	double d1=a+b;
	double d3=a*b;
	double d4=a*a*a;
	System.out.println("compare");
	System.out.println(c1+" "+d1);
	System.out.println(c3+" "+d3);
	System.out.println(c4+" "+d4);
    }


    /**arithmetic of QI2 polynomials*/

    public static void test2() {
	System.out.println("QI2Polynomial arithmetic");
	QI2Polynomial A=Debugger.randomCubic2();
	QI2Polynomial B=Debugger.randomCubic2();
	QI2Polynomial C1=QI2Polynomial.plus(A,B);
	QI2Polynomial C2=QI2Polynomial.minus(A,B);
	QI2Polynomial C3=QI2Polynomial.times(A,B);
	QI2Polynomial C4=QI2Polynomial.pow(A,3);
	double x=Math.random();
	double y=Math.random();
	double a=A.evaluate(x,y);
	double b=B.evaluate(x,y);
	double c1=C1.evaluate(x,y);
	double c2=C2.evaluate(x,y);
	double c3=C3.evaluate(x,y);
	double c4=C4.evaluate(x,y);
	double d1=a+b;
	double d2=a-b;
	double d3=a*b;
	double d4=a*a*a;
	System.out.println("compare");
	System.out.println(c1+" "+d1);
	System.out.println(c2+" "+d2);
	System.out.println(c3+" "+d3);
	System.out.println(c4+" "+d4);
    }


    /**arithmetic of QI2 rationals*/

    public static void test3() {
	System.out.println("QI2RationalFunction addition");
	QI2RationalFunction A=Debugger.randomCubicRat();
	QI2RationalFunction B=Debugger.randomCubicRat();
	QI2RationalFunction C1=QI2RationalFunction.plus(A,B);
	double x=Math.random();
	double y=Math.random();
	double a=A.evaluate(x,y);
	double b=B.evaluate(x,y);
	double c1=C1.evaluate(x,y);
	double d1=a+b;
	System.out.println("compare");
	System.out.println(c1+" "+d1);
    }


    /**arithmetic of QI2 polynomials*/

    public static void test4() {
	System.out.println("QI2Polynomial arithmetic");
	QI2Polynomial AA=Debugger.randomCubic2();
	QI2Polynomial BB=Debugger.randomCubic2();
	QI2Polynomial C1=QI2Polynomial.plus(AA,BB);
	QI2Polynomial C3=QI2Polynomial.times(AA,BB);
	QI2Polynomial C4=QI2Polynomial.pow(AA,3);


	double x=Math.random();
	double y=Math.random();
	double a=AA.evaluate(x,y);
	double b=BB.evaluate(x,y);
	double c1=C1.evaluate(x,y);
	double c3=C3.evaluate(x,y);
	double c4=C4.evaluate(x,y);
	double d1=a+b;
	double d3=a*b;
	double d4=a*a*a;
	System.out.println("compare");
	System.out.println(c1+" "+d1);
	System.out.println(c3+" "+d3);
	System.out.println(c4+" "+d4);
	System.out.println("printout of one of the polys we used.");
	AA.print();
    }

}

